/* Copyright (c) 2013 Cloudera, Inc. All rights reserved. */

#include <Python.h>
#include <sys/prctl.h>
#include <sys/signal.h>


static PyObject *
diewithparent(PyObject *self, PyObject *args)
{
  int result;

  result = prctl(PR_SET_PDEATHSIG, SIGTERM, 0, 0, 0);
  if (result < 0) {
    PyErr_SetFromErrno(PyExc_OSError);
    return NULL;
  }

  Py_RETURN_NONE;
}

static PyMethodDef methods[] = {
  {"diewithparent", diewithparent, METH_NOARGS, "Call prctl(PR_SET_PDEATHSIG)"},
  {NULL, NULL, 0, NULL}
};

PyMODINIT_FUNC
initdiewithparent(void)
{
  Py_InitModule("diewithparent", methods);
}
